; display two 4-digit numbers alternately on display interface


stack segment
dw 64 dup(0)
stack ends

data segment
num1 db 90h,90h,0c0h,0c0h        ; the code of 4-digit to display
num2 db 0c0h,0f9h,90h,80h        ; the code of 4-digit to display
data ends

code segment
assume cs:code ds:data ss:stack
start:mov ax,data
      mov ds,ax

      mov al,80h  ;initialize 8255 such that port-B & port-C as o/p
      mov dx,123h ;
      out dx,al   ;

      mov cx,0010  ; no. of alternate display

again:lea si,num1      ; load eff.addr of code to display in si reg.
      call display
      call delay
      lea si,num2
      call display
      call delay
      dec cx
      jnz again
      int 3h


  display proc near
      mov di,0004h    ; the number of digit to display is stored in di

   n2:mov bl,08h      ; to display one digit send 8 bit of code
      mov al,[si]     ; move mem.content (code) to al reg

   n1:rol al,1        ; bring ms bit to ls bit position
      push ax

      mov dx,121h     ;  send ms bit thru port-B (pb0) 
      out dx,al       ;


      mov al,00h      ;
      mov dx,122h     ;  send clock signal thru port-C
      out dx,al       ;
      mov al,0ffh     ;
      out dx,al       ;


      pop ax
      dec bl

      jnz n1
      inc si
      dec di
      jnz n2

      ret
   display endp


  delay proc near
      push si
      push di
      mov si,998h

   x2:mov di,0ffffh
   X1:dec di
      jnz x1
      dec si
      jnz x2
      pop di
      pop si
      ret

   delay endp

      code ends
      end start