;DEVELOP AND EXECUTE AN ASSEMBLY LANGUAGE PROGRAM TO SORT A GIVEN SET OF
;8-BIT UNSIGNED INTEGERS INTO ASCENDING ORDER USING BUBBLE SORT ALGORITHM.

stack segment
  dw 64 dup(0)
stack ends

data segment
  num db 12h,08h,10h,11h,07h
  length dw 0005h
data ends

code segment
 assume cs:code ds:data ss:stack
   start: mov ax,data
          mov ds,ax

          mov bx,length
          dec bx       ; n-1 passes required is stored in bx

outerloop:mov cx,bx    ; the number of comparison required is stored in cx
          lea si,num

innerloop:mov al,[si]  ;
          inc si       ;  if content of mem. whose effe.addr is in si is <
          cmp al,[si]  ;   content of mem whose effe.addr is in si+1
          jb go        ;  donot exchange the mem.  contents


          xchg al,[si]  ;
          dec si        ;  else exchange
          mov [si],al   ;
          inc si        ;


       go:dec cx         ;decrement number of comparison

          jnz innerloop


          dec bx         ; decrement number of passes

          jnz outerloop
          int 3h

          code ends
          end start