;USING CONDITIONAL ASSEMBLY, DEVELOP AND EXECUTE AN ASSEMBLY LANGUAGE PROGRAM
;WITH THE FOLLOWING FEATURES. IT USES ONE INPUT VALUE, AN UNSIGNED 16-BIT
;INTEGER CALLED X. IF EQN1 IS TRUE, IT ASSEMLES CODE WHICH COMPUTES
;3*X*X*X+4*X+5 AND THE 32-BIT RESULT IN A DOUBLE WORD MEMORY LOCATION.
;ASSUME OVERFLOW WILL NOT OCCUR). OTHERWISE IT ASSEMBLES CODE WHICH COMPUTES
;7*X+8 AND PLACES THE 32-BIT RESULT IN A DOUBLE WORD MEMORY LOCATION.

    equation macro x equ1
        if equ1
           mov ax,x  ;
           mov cx,x  ;  compute x*x
           mul cx    ;


           mov si,0000h   ;
           mov cx,ax      ;
           add ax,cx      ;
           jnc n1         ;
           inc si         ;  compute 3*x*x
       n1: add ax,cx      ;
           jnc n2         ;
           inc si         ;
       n2: mov cx,dx      ;
           add dx,cx      ;
           add dx,cx      ;
           add dx,si      ;


           add ax,0004     ;
           jnc n3          ;  compute 3*x*x + 4 . if carry ==1 increment dx
           inc dx          ;

       n3: mov di,x        ;
           dec di          ;
           mov cx,ax       ;
           mov bx,dx       ;
           mov si,0000h    ;   compute x(3*x*x+4)
    again: cmp di,0        ;
           je n4           ;
           add ax,cx       ;
           jnc n5          ;
           inc si          ;
       n5: add dx,bx       ;
           dec di          ;
           jmp again       ;
       n4: add dx,si       ;


           add ax,0005     ;compute x(3*x*x+4) +5. if carry==1 increment dx
           jnc n6
           inc dx

       n6: nop
       else

           mov ax,x      ;
           mov bx,0007   ;  compute 7*x+8
           mul bx        ;
           add ax,0008   ;

           jnc n7
           inc dx
       n7: nop
           endif
           endm




stack segment
  dw 64 dup(0)
stack ends

data segment
  x dw 0003h
  equ1 equ 0001h
  result dw 2 dup(0)
data ends

code segment
 assume cs:code ds:data ss:stack
   start: mov ax,data
          mov ds,ax

          equation x equ1


          lea si,result   ;
          mov [si],ax     ;
          inc si          ;  store result in dx_ax in mem.loc
          inc si          ;
          mov [si],dx     ;

          int 3h

          code ends
          end start