;read status of 3 input from logic controller. Assume these input represent
;a binary number x.  display  2*x using the same interface



stack segment
dw 64 dup(0)
stack ends

code segment
assume cs:code ss:stack
start :  mov dx,123h
        mov al,82h     ;initialize 8255 such that port-A as o/p & port-B
        out dx,al      ; as i/p

        mov dx,121h    ;Read status of logic controller from port-B
        in al,dx       ;

        and al,07h     ; mask the ms 5 bit

        shl al,01      ; multiply al by 2

        mov dx,120h    ; Display on the interface (port-A is o/p port)
        out dx,al      ;

        int 3h
        code ends
        end start