;DEVELOP AND EXECUTE AN ASSEMBLY LEVEL LANGUAGE TO IMPLEMENT BINARY SEARCH
;DLOGORITHM. ASSUME SORTED ARRAY OF 16-BIT NUMBERS. IF THE ELEMENT IS FOUND
;MOVE 11H TO MEMORY LOCATION AND ALSO FIND ITS POSITION ELSE MOVE 00H
;MEMORY LOCATION.
stack segment
  dw 64 dup(0)
stack ends

data segment
  num dw 1122h,3312h,4489h,4536h,6634h,7788h,9999h  ; store numbers in asc-
                                                    ;ending order
  length dw 0007h
  searchkey dw 3312h   ; element to search
  result db ?
  position dw ?
data ends

code segment
 assume cs:code ds:data ss:stack
   start: mov ax,data
          mov ds,ax

          mov bx,0001h     ; bx(low) =1  initially
          mov dx,length    ; dx(high) = n -------
          mov cx,searchkey

   again: lea si,num
          cmp bx,dx         ; if low>high then element to search is not
          ja failure        ; present in array

          mov ax,bx         ;
          add ax,dx         ;  mid=low+high/2
          shr ax,1          ;


          add si,ax          ;
          dec si             ; find address of  middle element 
          add si,si          ; and store in si

          cmp cx,[si]        ; compare searching element with middle element.
          jae bigger         ; if searching element > middle element goto
                             ; label bigger

          dec ax             ; else mid =mid-1
          mov dx,ax          ; move mid-1 to high(dx)
          jmp again          ; and repeat
  bigger: je success         ; check if middle element== search key
                             ; if equal goto success

          inc ax             ; else mid=mid+1
          mov bx,ax          ; move mid+1 to low(bx)
          jmp again          ; and repeat
 failure: mov result,00h
          jmp stop
 success: mov result,11h
          mov position,ax
    stop: int 3h
          code ends
          end start