; display a 4-digit number on display interface

stack segment
dw 64 dup(0)
stack ends

data segment
num db 0f9h,90h,0c0h,0c0h        ; the code of 4-digit to display
data ends

code segment
assume cs:code ds:data ss:stack
start:mov ax,data
      mov ds,ax

      mov al,80h  ;initialize 8255 such that port-B & port-C as o/p
      mov dx,123h ;
      out dx,al   ;

      lea si,num      ; load eff.addr of code to display in si reg.
      call display
      int 3h


  display proc near
      mov di,0004h    ; the number of digit to display is stored in di

   n2:mov bl,08h      ; to display one digit send 8 bit of code
      mov al,[si]     ; move mem.content (code) to al reg

   n1:rol al,1        ; bring ms bit to ls bit position
      push ax

      mov dx,121h     ;  send ms bit thru port-B (pb0) 
      out dx,al       ;


      mov al,00h      ;
      mov dx,122h     ;  send clock signal thru port-C
      out dx,al       ;
      mov al,0ffh     ;
      out dx,al       ;


      pop ax
      dec bl

      jnz n1
      inc si
      dec di
      jnz n2

      ret
   display endp
      code ends
      end start
