; 1.A)Develop and execute an assembly language program to find
     ;     the LCM of two 16-bit unsigned integers.

    stack segment
        dw 64 dup(0)
    stack ends


    data segment
       num1 dw 0020
       num2 dw 0015
       LCM  dw 2 dup (?)
    data ends


    code segment
       assume cs:code ds:data ss:stack

       START: mov AX,data     ;   load DS reg with starting 
              mov DS,AX       ;   address of data segment

              mov AX,num1
              mov BX,num2
              mov CX,num1
              mov DX,0000

       AGAIN: push AX         ;store the AX and DX in stack
              push DX         ;because the content of ax and dx reg.
                              ;is changed after division

              div  BX         ; perform (dx_ax)/bx
                              ; After division quotient is stored in ax reg.
                              ; and remainder is stored in dx reg.

              cmp  DX,0000    ; if remainder=0 then goto exit
                              ; and lcm =  (dx_ax) register pair
              je   exit       ;


              pop  DX         ; pop the values from stack
              pop  AX         ;

              add  AX,CX      ;ax=ax+cx

              jnc  NOADDI     ;after addition if no carry goto noaddi
                              ;else increment dx
              inc  DX

       NOADDI: jmp AGAIN      ; jump to again

       EXIT:  pop DX          ;
              pop AX          ;   pop ax and dx.  dx_ax  is lcm
                              ;   move that to mem.loc
              lea SI,LCM      ;
              mov [SI],AX     ;
              inc SI          ;
              inc SI          ;
              mov [SI],DX     ;



              INT 3H          ;    terminate the program

    code ends
    end START